;; This file is part of Poussin.

;; Poussin is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.

;; Pousin is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with Poussin.  If not, see <http://www.gnu.org/licenses/>.

;; Copyright (C) 2008 Nicolas Marti

(defvar poussin-mode-hook nil)

(defvar poussin-mode-map
  (let ((poussin-mode-map (make-keymap)))
    (define-key poussin-mode-map "\C-j" 'newline-and-indent)
    poussin-mode-map)
  "Keymap for poussin Major mode")

(add-to-list 'auto-mode-alist '("\\.p\\'" . poussin-mode))

(defconst poussin-font-lock-keywords-1
  (list
   '("\\<\\(con\\|match\\|of\\|return\\|type\\with\\|[!.;IV\\]\\)\\>" . font-lock-builtin-face)
   '("\\('\\w*'\\)" . font-lock-variable-name-face))
   "Minimal highlighting for poussin")

(defvar poussin-font-lock-keywords poussin-font-lock-keywords-1
  "Prout!!")

(defun poussin-indent-line ()
  "Indent"
  (interactive)
  (beginning-of-line)

  (if (bobp)
      (indent-line-to 0)

    (let ((not-indented t) cur-indent)
      

