(*
  This file is part of Poussin.

  Poussin is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Poussin is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Poussin.  If not, see <http://www.gnu.org/licenses/>.

  Copyright (C) 2008 Nicolas Marti
*)

open List;;
open String;;

type term =
    | Var of string
    | Lambda of string * term * term
    | Forall of string * term * term
    | Phi of string * int * term * term
    | Ind of string * term * term list
    | App of term * term
    | Match of term * term list
    | MatchT of term * term list * term (* add the type of the match block *)
    | Cons of int * term
    | Type
;;

type context = (string * term) list;;

type mgu =
    | Mgu of context
    | NoMgu
    | DnkMgu
;;
