(*
 This file is part of Poussin.

 Poussin is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Poussin is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Poussin.  If not, see <http://www.gnu.org/licenses/>.

 Copyright (C) 2008 Nicolas Marti
*)

  open Printf;;
  open Lexing;;
  open List;;
  open String;;
  
  open Def;;
  open Pprinter;;
  open Listutil;;
  open Freshness;;
  open Term;;
  open Alpharel;;
  open Betared;;
  open Termequiv;;
  open Typechecking
  open Unfold;;
  open Varset;;
  
  let typecheck ctxt te ty def bv =
    (*printf "unfolding ... \n\n"; flush stdout;*)
    if (valid_context ctxt def) then (
      if (typechecking ty Type ctxt def) then (
          (typechecking te ty ctxt def);
      ) else (
        printf "invalid type\n";           
        false
      )
    ) else (
      printf "invalid context\n";
      false
    )
  ;;
  
  let typecheck2 ctxt te ty def bv =
    (typechecking te ty ctxt def);;
  
  let typeinfer ctxt te def bv =
    if (valid_context ctxt def) then 
        (beta_red_infer te ctxt def)
      else None
  ;;

  let typeinfer2 ctxt te def bv =
    (simpl_infer te ctxt def)
  ;;
  
  
  let exec te def bv =
    (beta_red te bv def);;
  

  let simpl te def bv =
    (simpl_red te bv def);;
  
  
  let equiv t1 t2 def bv =
    (term_equiv t1 t2 bv def);
