{
(*
 This file is part of Poussin.

 Poussin is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Pousin is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Poussin.  If not, see <http://www.gnu.org/licenses/>.

 Copyright (C) 2008 Nicolas Marti
*)

  open Parser_interface;;

}

let digit = ['0'-'9']
let name = ['A'-'Z' 'a'-'z' '0'-'9']+
  rule token = parse
    | [' ' '\t' '\n' '\r']+ { token lexbuf }

    | "\\" { LAMBDA }
    | '!' { PHI }
    | 'I' { IND }
    | 'V' { FORALL }

    | "match" { MATCH }
    | "return" { RETURN }
    | "with" { WITH }
    | "type" { TYPE }
    | "cons" { CONS }
    | "of" { OF }

    | "Inductive" { INDUCTIVE }
    | "Recursive" { RECURSIVE }
    | "Lemma" { LEMMA }
    | "Drop" { DROP }
    | "Qed" { QED }
    | "Defined" { DEFINED }
    | "Extract Def" { EXTRACTDEF }
    | "Show Proof" { SHOWPROOF }
    | "Show Goal" { SHOWGOAL }
    | "Definition" { DEFINITION }


    | "Check" { CHECK } 
    | "Print" { PRINT } 
    | "Compute" { COMPUTE } 

    | "Quit" { QUIT }

    | "equiv" { EQUIV }
    | "intro" { INTRO } 
    | "generalize" { GENERALIZE } 
    | "as" { AS } 
    | "apply" { APPLY } 
    | "exact" { EXACT } 
    | "simpl" { SIMPL } 
    | "in" { IN } 
    | "factorize" { FACTORIZE } 
    | "destruct" { DESTRUCT } 
    | "unfold" { UNFOLD } 


    | digit+ as num { NUM (int_of_string num) }
    | name as word { NAME word }
        
    | '(' { LPAREN }
    | ')' { RPAREN }

    | '[' { LBRACK }
    | ']' { RBRACK }

    | '{' { LACCOL }
    | '}' { RACCOL }
       
    | ',' { COMMA }
    | ';' { SCOMMA }

    | '=' { EQ }
    | ':' { DDOT }
    | "|-" { TURNSTIL }
    | '.' { DOT }
    | '|' { PAR } 

        
    | eof { EOF }
